#include <stddef.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/time.h>


static long numForks = 100;

double doForks() {
    struct timeval tv_start, tv_end;
    pid_t child;
    int i;
    double diff, val;

    gettimeofday(&tv_start, NULL);
    for (i = 0; i < numForks; i++) {
        child = fork();
        if (child) {
            waitpid(child, NULL, 0);
        } else {
            exit(0);
        }
    }
    gettimeofday(&tv_end, NULL);

    diff = (tv_end.tv_sec * 1000000 + tv_end.tv_usec)
                       - (tv_start.tv_sec * 1000000 + tv_start.tv_usec);
    val = ((diff / 1000000) / numForks);
    return val;
}


int main(int argc, char *argv[]) {
    printf("Time taken per fork: \t\t%f\n", doForks());

    long mallocSize = 500 * 1024 * 1024;
    void *ptr = malloc(mallocSize);
    memset(ptr, 0,  mallocSize);

    printf("Time taken with 500MB: \t\t%f\n", doForks());

    ptr = malloc(mallocSize);
    memset(ptr, 0,  mallocSize);
    printf("Time taken with 1GB: \t\t%f\n", doForks());

    ptr = malloc(mallocSize);
    memset(ptr, 0,  mallocSize);
    ptr = malloc(mallocSize);
    memset(ptr, 0,  mallocSize);
    printf("Time taken with 2GB: \t\t%f\n", doForks());

    ptr = malloc(mallocSize);
    memset(ptr, 0,  mallocSize);
    ptr = malloc(mallocSize);
    memset(ptr, 0,  mallocSize);
    ptr = malloc(mallocSize);
    memset(ptr, 0,  mallocSize);
    ptr = malloc(mallocSize);
    memset(ptr, 0,  mallocSize);

    printf("Time taken with 4GB: \t\t%f\n", doForks());

    return 0;
}
